From: "Torsten Bögershausen" <tboegi@web.de>
To: Junio C Hamano <gitster@pobox.com>
Cc: "Jonathan Nieder" <jrnieder@gmail.com>,
"Torsten Bögershausen" <tboegi@web.de>,
git@vger.kernel.org, kraai@ftbfs.org
Subject: Re: [PATCH] tests: turn on test-lint-shell-syntax by default
Date: Tue, 15 Jan 2013 21:12:46 +0100 [thread overview]
Message-ID: <50F5B83E.9060800@web.de> (raw)
In-Reply-To: <7v4nikiu81.fsf@alter.siamese.dyndns.org>
On 13.01.13 23:38, Junio C Hamano wrote:
> Jonathan Nieder <jrnieder@gmail.com> writes:
>
>> Hi,
>>
>> Torsten Bögershausen wrote:
>>
>>> - /^\s*[^#]\s*which\s/ and err 'which is not portable (please use type)';
>>> + /^\s*[^#]\s*which\s+[-a-zA-Z0-9]+$/ and err 'which is not portable (please use type)';
>>
>> Hmm. Neither the old version nor the new one matches what seem to
>> be typical uses of 'which', based on a quick code search:
>>
>> if which sl >/dev/null 2>&1
>> then
>> sl -l
>> ...
>> fi
>>
>> or
>>
>> if test -x "$(which sl 2>/dev/null)"
>> then
>> sl -l
>> ...
>> fi
>
> Yes, these two misuses are what we want it to trigger on, so the
> test is very easy to trigger and produce a false positive, but does
> not trigger on what we really want to catch.
>
> That does not sound like a good benefit/cost ratio to me.
>
Thanks for comments, I think writing a regexp for which is difficult.
What do we think about something like this for fishing for which:
--- a/t/test-lib.sh
+++ b/t/test-lib.sh
@@ -644,6 +644,10 @@ yes () {
:
done
}
+which () {
+ echo >&2 "which is not portable (please use type)"
+ exit 1
+}
This will happen in runtime, which might be good enough ?
@Matt:
>The "[^#]" appears to ensure that there's at least one character
>before the which and that it's not a pound sign. Why is this done?
This is simply wrong.
next prev parent reply other threads:[~2013-01-15 20:13 UTC|newest]
Thread overview: 19+ messages / expand[flat|nested] mbox.gz Atom feed top
2013-01-12 5:50 [PATCH] tests: turn on test-lint-shell-syntax by default Torsten Bögershausen
2013-01-12 6:00 ` Junio C Hamano
2013-01-13 10:25 ` Torsten Bögershausen
2013-01-13 16:50 ` Matt Kraai
2013-01-13 17:32 ` Jonathan Nieder
2013-01-13 22:38 ` Junio C Hamano
2013-01-15 20:12 ` Torsten Bögershausen [this message]
2013-01-15 20:38 ` Junio C Hamano
2013-01-26 6:57 ` Torsten Bögershausen
2013-01-26 21:43 ` Junio C Hamano
2013-01-27 7:43 ` Torsten Bögershausen
2013-01-27 9:31 ` Jonathan Nieder
2013-01-27 13:13 ` Torsten Bögershausen
2013-01-27 17:34 ` Junio C Hamano
2013-01-27 20:25 ` Junio C Hamano
2013-02-05 20:36 ` Torsten Bögershausen
2013-02-05 20:52 ` Junio C Hamano
2013-02-05 21:56 ` Junio C Hamano
2013-01-27 17:15 ` Junio C Hamano
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=50F5B83E.9060800@web.de \
--to=tboegi@web.de \
--cc=git@vger.kernel.org \
--cc=gitster@pobox.com \
--cc=jrnieder@gmail.com \
--cc=kraai@ftbfs.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.